/*
 * OpenBehavior.java
 *
 * Created on 10. Mai 2003, 15:17
 */

package Aufgabe;
import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Frame;
import java.awt.GraphicsConfiguration;
import com.sun.j3d.utils.applet.MainFrame; 
import com.sun.j3d.utils.geometry.ColorCube;
import com.sun.j3d.utils.universe.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import java.awt.event.*;
import java.awt.AWTEvent;
import java.util.Enumeration;


public class OeffneBehavior extends Behavior {
     private TransformGroup  m_targetTG;   
     private WakeupCriterion pairPostCondition;
     private WakeupCriterion wakeupNextFrame;
     private WakeupCriterion AWTEventCondition;
     private Transform3D     t3D = new Transform3D();
     private Matrix3d        rotMat = new Matrix3d();
     private double          buchAngle;
       
     
    public OeffneBehavior(TransformGroup tg, Behavior Trigger) {
      m_targetTG = tg;
      AWTEventCondition = new WakeupOnBehaviorPost(Trigger, 7); //Wenn Pick Signal gibt
      wakeupNextFrame = new WakeupOnElapsedFrames(0);           //Wenn die Animation luft
    }
    
    public void setBehaviorObjectPartner(Behavior behaviorObject){
            pairPostCondition = new WakeupOnBehaviorPost(behaviorObject, 1);
        }
           
    public void initialize(){
       this.wakeupOn(AWTEventCondition);
       buchAngle = 0.0;
    }
    
   public void processStimulus(Enumeration criteria){
            
            if (criteria.nextElement().equals(pairPostCondition)){  //Wenn Schliesse fertig ist, auf Pick warten
                this.wakeupOn(AWTEventCondition);
                buchAngle = 0.0f;
            } else { // kann MousePick oder NextFrame sein
                if (buchAngle < 2.4){
                    buchAngle += 0.1;
                    if (buchAngle > 2.4) buchAngle = 2.4;
                    // Transform3D bekommen
                    m_targetTG.getTransform(t3D);
                   //Winkel setzen
                    t3D.rotY(buchAngle);
                    m_targetTG.setTransform(t3D);       //neue Transformation setzen
                    this.wakeupOn(wakeupNextFrame);
                } else { //oeffnen fertig, andere Behavior benachrichtigen
                   this.wakeupOn(pairPostCondition);
                    postId(1);
                }
            }
        }
    
}
